﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Controls;

namespace XamPivotGridValidationTooltipDemo
{
    public class ValueValidation : ValidationRule
    {
        public object Value { get; set; }
        public int Min { get; set; }
        public int Max { get; set; }
        public override ValidationResult Validate(object value, CultureInfo cultureInfo)
        {
            string result = ValidateValue(value);
            return new ValidationResult(result == null, result);
        }
        public string ValidateValue(object value)
        {
            if (string.IsNullOrEmpty((String)value))
            {
                return "Value cannot be null!";
            }
            try
            {
                int newValue = Int32.Parse((String)value);
                if ((newValue < this.Min) || (newValue > this.Max))
                {
                    return "Value is out of the range: " + this.Min + " - " + this.Max + ".";
                }
            }
            catch (Exception e)
            {
                return "Value has illegal characters or " + e.Message;
            }
            return null;
        }
    }
}
